WPParser Class Reference

the main class to read a Writerperfect file More...

`#include <WPParser.hxx>`

Inheritance diagram for WPParser:

## Public Member Functions

| WPParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor More...
virtual | ~WPParser ()
| destructor More...
bool | checkHeader (MWAWHeader *header, bool strict=false)
| checks if the document header is correct (or not) More...
void | parse (WPXDocumentInterface *documentInterface)
| virtual function used to parse the input More...
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor More...
int | version () const
| returns the works version More...
void | setVersion (int vers)
| sets the works version More...

## Protected Member Functions

void | init ()
| inits all internal variables More...
void | createDocument (WPXDocumentInterface *documentInterface)
| creates the listener which will be associated to the document More...
bool | createZones ()
| finds the different objects zones More...
bool | readPrintInfo ()
| read the print info zone More...
bool | readWindowsInfo (int zone)
| read the main info for zone ( 0: MAIN ZONE, 1 : HEADER, 2 : FOOTER ) More...
bool | sendWindow (int zone, Vec2i limits=Vec2i(-1,-1))
| send a zone ( 0: MAIN ZONE, 1 : HEADER, 2 : FOOTER ) More...
bool | readWindowsZone (int zone)
| read the page info zone More...
bool | readPageInfo (int zone)
| read the page info zone More...
bool | readColInfo (int zone)
| read the col info zone ? More...
bool | readParagraphInfo (int zone)
| read the paragraph info zone More...
bool | findSection (int zone, Vec2i limits, MWAWSection &sec)
| try to find the data which correspond to a section ( mainly column ) More...
bool | readSection (WPParserInternal::ParagraphInfo const &info, bool mainBlock)
| read a section More...
bool | readText (WPParserInternal::ParagraphInfo const &info)
| read a text More...
bool | readTable (WPParserInternal::ParagraphInfo const &info)
| read a table More...
bool | readGraphic (WPParserInternal::ParagraphInfo const &info)
| read a graphic More...
bool | readUnknown (WPParserInternal::ParagraphInfo const &info)
| read a unknown section More...
double | getTextHeight () const
| returns the page height, ie. paper size less margin (in inches) and header/footer More...
void | newPage (int number)
| adds a new page More...
bool | readParagraphData (WPParserInternal::ParagraphInfo const &info, bool hasFonts, WPParserInternal::ParagraphData &data)
| reads a paragraph data More...
MWAWParagraph | getParagraph (WPParserInternal::ParagraphData const &data)
| returns a paragraph corresponding to a paragraph data More...
bool | readFonts (int nFonts, int type, std::vector< WPParserInternal::Font > &fonts)
| reads a list of font (with position) More...
bool | readLines (WPParserInternal::ParagraphInfo const &info, int nLines, std::vector< WPParserInternal::Line > &lines)
| reads a list of line (with position) More...
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWParser (MWAWParserStatePtr state)
| constructor using a state More...
MWAWParserStatePtr | getParserState ()
| returns the parser state More...
MWAWHeader * | getHeader ()
| returns the header More...
MWAWInputStreamPtr & | getInput ()
| returns the actual input More...
MWAWContentListenerPtr & | getListener ()
| returns the listener More...
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension More...
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension More...
double | getFormLength () const
| returns the form length More...
double | getFormWidth () const
| returns the form width More...
double | getPageLength () const
| returns the page length (form length without margin ) More...
double | getPageWidth () const
| returns the page width (form width without margin ) More...
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser More...
void | setListener (MWAWContentListenerPtr &listener)
| sets the listener More...
void | resetListener ()
| resets the listener More...
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter More...
void | setFontConverter (MWAWFontConverterPtr fontConverter)
| sets the font convertor More...
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document More...
void | setAsciiName (char const *name)
| Debugging: change the default ascii file. More...
std::string const & | asciiName () const
| return the ascii file name More...

## Protected Attributes

shared_ptr < WPParserInternal::State > | m_state
| the state More...

## Friends

class | WPParserInternal::SubDocument

## Detailed Description

the main class to read a Writerperfect file

## Constructor & Destructor Documentation

WPParser::WPParser | ( | MWAWInputStreamPtr | input,
|  | MWAWRSRCParserPtr | rsrcParser,
|  | MWAWHeader * | header
| ) |  |

constructor

WPParser::~WPParser | ( |  | ) |

virtual

destructor

## Member Function Documentation

bool WPParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = `false`
| ) |  |

virtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by parse().

void WPParser::createDocument | ( | WPXDocumentInterface * | documentInterface | ) |

protected

creates the listener which will be associated to the document

Referenced by parse().

bool WPParser::createZones | ( |  | ) |

protected

finds the different objects zones

Referenced by parse().

bool WPParser::findSection | ( | int | zone,
|  | Vec2i | limits,
|  | MWAWSection & | sec
| ) |  |

protected

try to find the data which correspond to a section ( mainly column )

Referenced by sendWindow().

MWAWParagraph WPParser::getParagraph | ( | WPParserInternal::ParagraphData const & | data | ) |

protected

returns a paragraph corresponding to a paragraph data

Referenced by readText().

double WPParser::getTextHeight | ( |  | ) | const

protected

returns the page height, ie. paper size less margin (in inches) and header/footer

Referenced by readPageInfo().

void WPParser::init | ( |  | ) |

protected

inits all internal variables

Referenced by WPParser().

void WPParser::newPage | ( | int | number | ) |

protected

adds a new page

Referenced by sendWindow().

void WPParser::parse | ( | WPXDocumentInterface * | documentInterface | ) |

virtual

virtual function used to parse the input

Implements MWAWParser.

bool WPParser::readColInfo | ( | int | zone | ) |

protected

read the col info zone ?

Referenced by readWindowsZone().

bool WPParser::readFonts | ( | int | nFonts,
|  | int | type,
|  | std::vector< WPParserInternal::Font > & | fonts
| ) |  |

protected

reads a list of font (with position)

Referenced by readParagraphData().

bool WPParser::readGraphic | ( | WPParserInternal::ParagraphInfo const & | info | ) |

protected

read a graphic

Referenced by sendWindow().

bool WPParser::readLines | ( | WPParserInternal::ParagraphInfo const & | info,
|  | int | nLines,
|  | std::vector< WPParserInternal::Line > & | lines
| ) |  |

protected

reads a list of line (with position)

Referenced by readText().

bool WPParser::readPageInfo | ( | int | zone | ) |

protected

read the page info zone

Referenced by readWindowsZone().

bool WPParser::readParagraphData | ( | WPParserInternal::ParagraphInfo const & | info,
|  | bool | hasFonts,
|  | WPParserInternal::ParagraphData & | data
| ) |  |

protected

reads a paragraph data

Referenced by readGraphic(), readSection(), readTable(), readText(), and readUnknown().

bool WPParser::readParagraphInfo | ( | int | zone | ) |

protected

read the paragraph info zone

Referenced by readWindowsZone().

bool WPParser::readPrintInfo | ( |  | ) |

protected

read the print info zone

Referenced by createZones().

bool WPParser::readSection | ( | WPParserInternal::ParagraphInfo const & | info,
|  | bool | mainBlock
| ) |  |

protected

read a section

Referenced by sendWindow().

bool WPParser::readTable | ( | WPParserInternal::ParagraphInfo const & | info | ) |

protected

read a table

Referenced by sendWindow().

bool WPParser::readText | ( | WPParserInternal::ParagraphInfo const & | info | ) |

protected

read a text

Referenced by sendWindow().

bool WPParser::readUnknown | ( | WPParserInternal::ParagraphInfo const & | info | ) |

protected

read a unknown section

Referenced by sendWindow().

bool WPParser::readWindowsInfo | ( | int | zone | ) |

protected

read the main info for zone ( 0: MAIN ZONE, 1 : HEADER, 2 : FOOTER )

Referenced by checkHeader(), and createZones().

bool WPParser::readWindowsZone | ( | int | zone | ) |

protected

read the page info zone

Referenced by createZones().

bool WPParser::sendWindow | ( | int | zone,
|  | Vec2i | limits = `Vec2i(-1,-1)`
| ) |  |

protected

send a zone ( 0: MAIN ZONE, 1 : HEADER, 2 : FOOTER )

Referenced by parse().

## Friends And Related Function Documentation

friend class WPParserInternal::SubDocument

friend

## Member Data Documentation

shared_ptr<WPParserInternal::State> WPParser::m_state

protected

the state

Referenced by checkHeader(), createDocument(), createZones(), findSection(), getTextHeight(), init(), newPage(), readColInfo(), readPageInfo(), readParagraphInfo(), readWindowsInfo(), readWindowsZone(), and sendWindow().

The documentation for this class was generated from the following files:

- WPParser.hxx
- WPParser.cxx